
; PET soundz
;
; Compiles with DASM
;
; Playback test. You don't need this in your demo.


		processor 6502
	
		org     $0401
		.byte   $0b,$10,$ef,$00,$9e,$31,$30,$33,$38,0,0,0,0
		org     $040e


; Clear screen, copy text display.

 		lda #147
 		jsr $ffd2
 		
 		ldx #$00
drawscreen
 		lda displayscreen,x
 		sta $8000,x
 		lda displayscreen+$100,x
 		sta $8100,x
 		lda displayscreen+$200,x
 		sta $8200,x
 		lda displayscreen+$300,x
 		sta $8300,x
 		inx
 		bne drawscreen
 		
		sei
		lda $90
		sta irqsave+1	
		lda $91
		sta irqsave+2
		sei
		lda #<irq
		sta $90
		lda #>irq
		sta $91


; Setup song, just turns speaker on tbh.

		jsr songsetup

; Loop forever...
		cli

loop

		jmp loop


irq

; Play frame of the song

		jsr songstart

; Update screen display

		lda #$64
		sta draw1+$01
		lda #$65
		sta draw2+$01
		lda #$80
		sta draw1+$02
		sta draw2+$02
		
		ldx #$00
drawreg
		lda songpos,x
		jsr gethex
		lda $80
draw1
		sta $8010
		lda $81
draw2
		sta $8011

		clc
		lda draw2+$01
		adc #$28
		sta draw2+$01
		clc
		lda draw1+$01
		adc #$28
		cmp draw1+$01
		sta draw1+$01
		bcs nomulti
		inc draw1+$02
		inc draw2+$02
nomulti
		inx
		cpx #$10
		bne drawreg
		
irqsave
    		jmp $0000

gethex 
		pha

		and #$0f
		tay
		lda hexchars,y
		sta $81

		pla
		lsr
		lsr
		lsr
		lsr
		tay
		lda hexchars,y
		sta $80
		rts

hexchars 
		.byte $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$01,$02,$03,$04,$05,$06


; Screen display.  Can you tell this was auto generated? :P
		
displayscreen

		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $10
		 .byte $05
		 .byte $14
		 .byte $20
		 .byte $13
		 .byte $0F
		 .byte $15
		 .byte $0E
		 .byte $04
		 .byte $1A
		 .byte $20
		 .byte $16
		 .byte $31
		 .byte $2E
		 .byte $30
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $13
		 .byte $0F
		 .byte $0E
		 .byte $07
		 .byte $20
		 .byte $10
		 .byte $0F
		 .byte $13
		 .byte $09
		 .byte $14
		 .byte $09
		 .byte $0F
		 .byte $0E
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $12
		 .byte $05
		 .byte $10
		 .byte $05
		 .byte $01
		 .byte $14
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $10
		 .byte $01
		 .byte $14
		 .byte $14
		 .byte $05
		 .byte $12
		 .byte $0E
		 .byte $20
		 .byte $10
		 .byte $0F
		 .byte $13
		 .byte $09
		 .byte $14
		 .byte $09
		 .byte $0F
		 .byte $0E
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $14
		 .byte $01
		 .byte $02
		 .byte $0C
		 .byte $05
		 .byte $20
		 .byte $0F
		 .byte $06
		 .byte $06
		 .byte $13
		 .byte $05
		 .byte $14
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $03
		 .byte $15
		 .byte $12
		 .byte $12
		 .byte $05
		 .byte $0E
		 .byte $14
		 .byte $20
		 .byte $14
		 .byte $05
		 .byte $0D
		 .byte $10
		 .byte $0F
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $14
		 .byte $09
		 .byte $03
		 .byte $0B
		 .byte $13
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $14
		 .byte $05
		 .byte $0D
		 .byte $10
		 .byte $0F
		 .byte $20
		 .byte $13
		 .byte $05
		 .byte $14
		 .byte $14
		 .byte $09
		 .byte $0E
		 .byte $07
		 .byte $20
		 .byte $01
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $14
		 .byte $05
		 .byte $0D
		 .byte $10
		 .byte $0F
		 .byte $20
		 .byte $13
		 .byte $05
		 .byte $14
		 .byte $14
		 .byte $09
		 .byte $0E
		 .byte $07
		 .byte $20
		 .byte $02
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $03
		 .byte $15
		 .byte $12
		 .byte $12
		 .byte $05
		 .byte $0E
		 .byte $14
		 .byte $20
		 .byte $0E
		 .byte $0F
		 .byte $14
		 .byte $05
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $0C
		 .byte $05
		 .byte $0E
		 .byte $07
		 .byte $14
		 .byte $08
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $03
		 .byte $15
		 .byte $12
		 .byte $12
		 .byte $05
		 .byte $0E
		 .byte $14
		 .byte $20
		 .byte $09
		 .byte $0E
		 .byte $13
		 .byte $14
		 .byte $12
		 .byte $15
		 .byte $0D
		 .byte $05
		 .byte $0E
		 .byte $14
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $10
		 .byte $0F
		 .byte $13
		 .byte $09
		 .byte $14
		 .byte $09
		 .byte $0F
		 .byte $0E
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $14
		 .byte $01
		 .byte $02
		 .byte $0C
		 .byte $05
		 .byte $20
		 .byte $0F
		 .byte $06
		 .byte $06
		 .byte $13
		 .byte $05
		 .byte $14
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $0C
		 .byte $0F
		 .byte $0F
		 .byte $10
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $10
		 .byte $09
		 .byte $14
		 .byte $03
		 .byte $08
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $10
		 .byte $09
		 .byte $14
		 .byte $03
		 .byte $08
		 .byte $20
		 .byte $13
		 .byte $17
		 .byte $05
		 .byte $05
		 .byte $10
		 .byte $3A
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $43
		 .byte $0F
		 .byte $12
		 .byte $02
		 .byte $43
		 .byte $32
		 .byte $30
		 .byte $31
		 .byte $30
		 .byte $43
		 .byte $43
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20
		 .byte $20

    		include petdriver.asm
    		